#!/usr/bin/perl -w
#use strict;
use IO::Socket;

my $port  = shift || 8000;
my $playList = shift || "playlist.m3u";
my $ran = shift || 1;

$SIG{CHLD} = 'IGNORE';
my $S_Sock = IO::Socket::INET->new(LocalPort => $port,
				    Listen => 10,
				    Proto => 'tcp',
				    Reuse => 1
				   );
$S_Sock || die "failed to create server socket: $!\n";
while (my $C_Sock = $S_Sock->accept){
	my $pid;
	die "Fork Failed: $!\n" unless defined ($pid = fork());
	if($pid == 0){ #Child Process!
		$S_Sock->close; #done w/ this now
		play_songs($C_Sock,$playList,$ran);
		exit 0;
	}else{ #Parent Process!
		warn "New Client: ",$C_Sock->peerhost,"\n";
		$C_Sock->close;
	}
}

sub play_songs{
	my $Sock = shift;
	my $playList= shift;
	my $ran = shift;
	my $currentTrack = 0;
		
	open PLAYLIST,$playList or die;
	my @songs = <PLAYLIST>;
	close PLAYLIST;
	chomp @songs;

	srand(time / $$);
	
	while(){
		my $song;
		if($ran == 1){
			$song = $songs[rand @songs];
		}else{
			$song = $songs[$currentTrack];
		}
		print $Sock "HTTP/1.0 200 OK\n";
		print $Sock "Content-Type: audio/x-mp3stream\n";
		print $Sock "Cache-Control: no-cache\n";
		print $Sock "Pragma: no-cache\n";
		print $Sock "Connection: close \n";
		print $Sock "x-audiocast-name: MP3R4ND0N\n\n";

		warn( "playing $song\n");
		open SONG, $song || next;
		binmode(SONG);
	
		my $read_status = 1;
		my $print_status = 1;
		my $chunk;

		while($read_status && $print_status){
			$read_status = read(SONG,$chunk,1024);
			if(defined $chunk && defined $read_status){
				$print_status = print $Sock $chunk;
			}
			undef $chunk;
		}
		close SONG;
		
		unless(defined $print_status){
			$Sock->close;
			exit 0;
		}
	}
}
